/*
Name:       Weslley De Souza
Date:       16.08.2017
Version:    1.0
Notes:      STRICT MODE

CHANGELOG:

 */
'use strict';

//Libraries
const _driver   = require('selenium-webdriver');
const webdriver = require('selenium-webdriver');
const By        = require('selenium-webdriver').By;
const until     = require('selenium-webdriver').until;

const moment    = require('moment');
var   request   = require('request');

//Spooky Library
try {
    var Spooky = require('spooky');
}
catch (e) {
    //npm i tiny-jsonrpc
    var Spooky = require('../lib/spooky');
}

//Database connection
/*
const mysql = require('mysql2');
const connection = mysql.createConnection({
    host: '192.168.254.75',
    user: 'wds',
    password:'SAS7Ukku',
    database: 'hotelpartner'
});
*/
const connection = null;

//###Variables
var ISFETCHING  =  false;
const joburls   =  {
    "Booking":[]
};
const skipjobs  =  {
    "Booking":[]
};
const hotellist =  {
    "Trivago":[],
    "Booking":[],
    "Hrs":[],
    "expedia":[],
    "compared":{
        "Booking":[],
    }
};
const bewertung = ["Gut","Fabelhaft","Hervorragend"]


//###Classes
class Hotel{

    constructor(name=null, price1=null,price2=null,  place=null, stars=null,  rating=null, people=null, cancellation=null, peopleview=null, roomleft=null, inclusive=null, start=null, end=null, site=null) {

        //ref
        this.name         = name;
        this.place        = place;
        this.rating       = rating;
        this.price1       = price1;
        this.price2       = price2;
        this.people       = people;
        this.stars        = stars;
        this.roomleft     = roomleft;
        this.peopleview   = peopleview;
        this.cancellation = cancellation;
        this.inclusive    = inclusive;
        this.site         = site;
        this.datestart    = start;
        this.dateend      = end;
        this.img         = null;

        //as obj
        const obj = { };
        Object.setPrototypeOf(obj, Hotel.prototype);
        obj.name            = name;
        obj.place           = place;
        obj.stars           = stars;
        obj.rating          = rating;
        obj.price1          = price1;
        obj.price2          = price2;
        obj.people          = people;
        obj.roomleft        = roomleft;
        obj.peopleview      = peopleview;
        obj.cancellation    = cancellation;
        obj.inclusive       = inclusive;
        obj.site            = site;
        obj.datestart       = start;
        obj.dateend         = end;
        obj.img            = null;

        return obj

    }

    toString() {
        return `${this.name} | ${this.place} | ${this.rate} | ${this.price} | ${this.site}`
    }

    print () {
        console.log( this.toString() );
    }

    printToURL() {
        let _url = `{"Name":"${this.name}","Street":"","City":"${this.place}","Stars":"${this.stars}","Rating":"${this.rating}","Preferred":"0","LastBooking":"0","Success":"0","Values":{"${this.datestart}":"${this.price1};${this.price2};0;0;0;0"}}`;
        return _url;
    }
   }


//###Functions

/**
 * Fetch BookingCOM
 *
 * return  hotellist.Booking
 */
function getBooking(destid,place,start,end,room=1,adlt=1,child=0,nextpage=false,job,dbid) {

    //STILL IN TEST


    let   adult             = adlt;
    const startdate         = moment(start);
    const enddate           = moment(end);

    let totadd              = 0;
    var pageoffset          = 0;
    let page                = 0;


    const dt= startdate.format('YYYY-MM-DD');
    const city = {
        name:place,
        id:destid,
        values:[]
    }

    //add new destID
    let cityindex = hotellist.Booking.findIndex(b=>b.id==destid);

    if(cityindex==-1)
        hotellist.Booking.push(city);

    //add new date
          cityindex = hotellist.Booking.findIndex(b=>b.id==destid)
    const dateindex = hotellist.Booking[cityindex].values.findIndex(b=>b.date==dt)

    if(dateindex>=0) hotellist.Booking[cityindex].values[dateindex].values = [];

    else
        hotellist.Booking[cityindex].values.push({
            'date':dt,
            values:[]
        })


    console.log(`https://www.booking.com/searchresults.de.html?src=index&dest_type=city&dest_id=${destid}&ssne=${place}&ssne_untouched=${place}&ss=${place}&checkin_monthday=${startdate.format('DD')}&checkin_year_month=${startdate.format('YYYY-M')}&checkout_monthday=${enddate.format('DD')}&checkout_year_month=${enddate.format('YYYY-M')}&ci_date=${startdate.format('YYYY-MM-DD')}&co_date=${enddate.format('YYYY-MM-DD')}&room=${room}&no_rooms=${room}&group_adults=${adult}&group_children=${child};unchecked_filter=out_of_stock%20;nflt=;unchecked_filter=out_of_stock&selected_currency=hotel_currency&changed_currency=1`)
    return  new Promise(function (resolve) {
        // Prevent multiple Fetch
        //if(ISFETCHING){resolve(false);return};
        //ISFETCHING= true;

        //**recursive Function**
        //function will be called while there is a next button on the page
        function getData() {

           //let url = `https://www.booking.com/searchresults.de.html?l&checkin_monthday=${startdate.format('DD')}&checkin_year_month=${startdate.format('YYYY-M')}&checkout_monthday=${enddate.format('DD')}&checkout_year_month=${enddate.format('YYYY-M')}&ci_date=${startdate.format('YYYY-MM-DD')}&co_date=${enddate.format('YYYY-MM-DD')}&room1=A%2CA&no_rooms=1&group_adults=${adult}&group_children=${child}&ss_raw=${place}&ac_position=0&dest_id=${destid}&dest_type=city&search_pageview_id=b70c6c0a3fea0249&search_selected=true&search_pageview_id=b70c6c0a3fea0249&ac_suggestion_list_length=5&ac_suggestion_theme_list_length=0&nflt=;unchecked_filter=out_of_stock&selected_currency=hotel_currency&changed_currency=1`
             let url = `https://www.booking.com/searchresults.de.html?src=index&dest_type=city&dest_id=${destid}&ssne=${place}&ssne_untouched=${place}&ss=${place}&checkin_monthday=${startdate.format('DD')}&checkin_year_month=${startdate.format('YYYY-M')}&checkout_monthday=${enddate.format('DD')}&checkout_year_month=${enddate.format('YYYY-M')}&ci_date=${startdate.format('YYYY-MM-DD')}&co_date=${enddate.format('YYYY-MM-DD')}&room=${room}&no_rooms=${room}&group_adults=${adult}&group_children=${child};unchecked_filter=out_of_stock%20;nflt=;unchecked_filter=out_of_stock&selected_currency=hotel_currency&changed_currency=1`
            if(nextpage)
            {
                pageoffset+=20;
                url.replace(`&rows=16&offset=${pageoffset}`,'')
                url += `&rows=16&offset=${pageoffset}`
            }

            //Create new Instance of Webdrvier and pass CasperJS parameters
            //Spooky does not support ES6!
            const spooky = new Spooky({

                    pageSettings: {
                        loadImages: false,
                        loadPlugins: false,
                        userAgent: 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1588.0 Safari/537.36'
                    },
                    verbose: true,
                    logLevel: "debug",
                },
            function (err)                                        {
                    //Mozilla/5.0 (X11; Linux i686; rv:14.0) Gecko/20100101 Firefox/14.0.1 Iceweasel/14.0.1
                    //Chrome/37.0.2062.120
                    spooky.userAgent('Mozilla/5.0 (X11; Linux i686; rv:14.0) Gecko/20100101 Firefox/14.0.1 Iceweasel/14.0.1');
                    spooky.start(url);
                    //Show current page
                    //check for pagination
                    spooky.then(function () {
                        this.emit('currentpage',this.getCurrentUrl())
                        this.scrollTo(1000, 1200);
                        this.emit('pagination',    this.evaluate(function () {
                            //get elements
                            var next = document.getElementsByClassName("paging-next");
                            return next[0].innerText

                        }));

                    });
                    //Get Elements
                    //TODO: If booking changes their classname : change it here
                    spooky.then(function() {
                        //wait for elements to be loaded
                        this.capture('page.png');
                        this.scrollTo(100, 100);
                        this.emit('parse',  this.evaluate(function () {
                            var items =null
                            var mystring = "";
                            items = document.getElementsByClassName("sr_item_default");
                            var imgs = document.querySelectorAll('.sr_item_default img');
                            if(items)
                            {
                                for(var i=0; i<items.length;i++)
                                {
                                    //add  divider to split
                                    mystring += items[i].innerText + " \n"+ imgs[i].src+ " "+ "myH0TeL";
                                }
                            }
                            return mystring;
                        }));
                    })
                    //start
                    spooky.run();
                });
            spooky.on('pagination', function (text)               {
                if(text=='Nächste Seite')
                {
                    page++;
                    //console.info("page offset "+ pageoffset)
                    console.info("========================= page: "+   page+" Adult: "+adult+ " Datum:"+ startdate.format('DD.MM.YYYY')+" ========================" )
                    nextpage =true
                }
                else {
                    console.info("========================= page: "+ (page+1)+" Adult: "+adult+" ========================" )
                    nextpage = false;
                }

            });
            spooky.on('currentpage',    function (text)           {
                console.log(" ")
               // console.info(text)

            });
            spooky.on('parse',          function (text)           {
                let totaddpage = 0;

                if(text)
                {
                    const hotels = text.split("myH0TeL");
                    console.log("Booking array length: "+hotels.length);
                    hotels.forEach(items=>{
                    const words    = items.split("\n");
                   //rabattpreis
                    let lastprice  = true;

                        const parsedhotel = parseBooking(words/*array*/,lastprice/*aktion price*/,dt,enddate.format('YYYY-MM-DD'),'Booking.com',adult)

                        //const
                            const cindex = hotellist.Booking.findIndex(b=>b.id==destid)
                        const dindex = hotellist.Booking[cindex].values.findIndex(b=>b.date==dt)
                        const   idx   =  hotellist.Booking[cindex].values[dindex].values.findIndex(i=>i.name == parsedhotel.name);


                        if( parsedhotel.name  && parsedhotel.price1 && idx == -1)
                        {

                            console.log("adding " + parsedhotel.name + " p1:"+parsedhotel.price1)
                            hotellist.Booking[cindex].values[dindex].values.push(parsedhotel);

                            totadd++;
                            totaddpage++;
                        }
                        else
                         {
                            if(idx >-1 && parsedhotel.name && adult==2)
                            {
                                    hotellist.Booking[cindex].values[dindex].values[idx].price2 = parsedhotel.price2;
                                    console.log("update "+parsedhotel.name +" p2:"+parsedhotel.price2)
                            }
                        }
                    });
                    console.log("pagetot: "+totaddpage);
                    console.log("tot: "    +totadd);
                    //go to next page or add adult
                    //then exit
                    if(nextpage )
                    {
                        setTimeout(()=>{
                            getData();
                        },200);
                        spooky.destroy();
                        return;
                    }
                    else {
                        if(adult==1)
                          {
                            setTimeout(()=>{
                                nextpage=true;
                                page = 0;
                                adult=2;
                                pageoffset=-20
                                getData();
                            },200);

                            spooky.destroy();
                        }
                        else
                          {
                            console.log(">>DONE<<")
                            setTimeout(()=>{
                                ISFETCHING= false;
                                resolve(JSON.stringify(hotellist))
                            },200)
                            spooky.destroy();
                        }
                    }
                }
                else
                {
                    //add adult
                    if(adult==1)
                    {
                        setTimeout(()=>{
                            nextpage=true
                            page = 0;
                            pageoffset=-20;
                            adult=2;
                            getData();
                        },200);
                        spooky.destroy();
                    }
                    //finish
                    else {
                        ISFETCHING= false;
                        console.log("no elements found")
                        console.log(">>DONE<<")
                        resolve(JSON.stringify(hotellist))
                        spooky.destroy();
                    }
                }
            });
            spooky.on('error',          function(msg,backtrace)   {
                console.log(msg)
            });
        }
        getData();
    })
}


/*bellow get functions not testet*/
function getTrivago(place,room='1',start,end) {
    let startdate =moment(start)
    let endtdate =moment(end)

    if(room=='1'){
        room='RoomType=1'
    }
    else {
        room='RoomType=7'
    }

    return  new Promise(function (resolve) {

        resolve([])
        return
        // open selenium
        var driver = new webdriver.Builder().forBrowser('phantomjs').build();
        // maximize the window
        driver.manage().window().maximize();
        // delete all cookies
        driver.manage().deleteAllCookies();

        // navigate to Trivago
        driver.get(`https://www.trivago.ch/`).then(()=> {

            setTimeout(() => {
                driver.wait(until.titleIs('trivago.ch - Hotelpreisvergleich | Günstige Hotels finden | Hotelsuche')).then(function () {
                    const input = driver.findElement(By.xpath("//*[@id='horus-querytext']"));
                    input.sendKeys(place);
                    input.sendKeys(' ');
                    input.sendKeys(_driver.Key.DOWN);
                    input.sendKeys(_driver.Key.ENTER);
                }).then(() => {
                    setTimeout(() => {
                        driver.getCurrentUrl().then(function () {
                            return driver.getCurrentUrl();
                        }).then(function (currentUrl) {

                            let url = currentUrl.replace('Barr%5D=', 'Barr%5D=' + startdate.format('YYYY-MM-DD')+"&n=").replace('dep%5D=2', 'dep%5D=' + endtdate.format('YYYY-MM-DD')+'nn=').replace('RoomType=',room+'nnn=')

                            driver.get(`url`).then(() => {

                                driver.wait(until.titleIs('trivago.ch - Hotelpreisvergleich | Günstige Hotels finden | Hotelsuche')).then(function () {
                                    setTimeout(()=>{
                                        let a;
                                        //               a = driver.findElements(By.className("item"))
                                        //          if (a.length == 0)
                                        a = driver.findElements(By.className("hotel"))

                                        a.then(items => {
                                            hotellist.Trivago = [];
                                            items.forEach(element => {
                                                element.getText().then(text => {

                                                    let words = text.split("\n");
                                                    const myhotel = parseTrivago(words,startdate.format('YYYY-MM-DD'),endtdate.format('YYYY-MM-DD'),'Trivago')
                                                    hotellist.Trivago.push(myhotel)

                                                });

                                            })
                                        }).then(() => {
                                            resolve(JSON.stringify(hotellist))
                                        })
                                    },1000)
                                })

                            });
                        }, 2000)
                    })
                }, 1000)
            })
        })

    })
}
function getHrs(place,start,end)              {
    let startdate =moment(start)
    let endtdate =moment(end)
    return  new Promise(function (resolve) {
        try {
            // open selenium
            var driver = new webdriver.Builder().forBrowser('phantomjs').build();
            // maximize the window
            driver.manage().window().maximize();
            // delete all cookies
            driver.manage().deleteAllCookies();

            // navigate to hrs
            driver.get("https://www.hrs.de/");



            driver.getTitle().then(function(title) {
                console.log(title)
            });
            driver.wait(until.titleIs('HRS - Hotel Reservation Service | Hotel finden und günstige Hotels buchen')).then(function () {


                const input = driver.findElement(By.xpath("//*[@id='destiny']"));
                const von = driver.findElement(By.xpath("//input[@id='start_stayPeriod']"));
                const bis = driver.findElement(By.xpath("//input[@id='end_stayPeriod']"));

                input.sendKeys(place);
                input.sendKeys(' ');
                input.sendKeys(_driver.Key.DOWN);
                input.sendKeys(_driver.Key.ENTER);

                setTimeout(()=>{
                    von.sendKeys(startdate.format('YYYY.MM.DD'));
                    bis.sendKeys(endtdate.format('YYYY.MM.DD'));

                    //Close Calendar
                    input.click();
                    console.log("->")

                    const btn = driver.findElement(By.xpath("//*[@id='searchForm']/fieldset[3]/input"));
                    btn.click();
                },290)

            }).then(()=>{

                setTimeout(()=>{
                    console.log("get hotelTeaserContainer")
                    let a= driver.findElements(By.className("hotelTeaserContainer"));
                    a.then(items=>{
                        console.error(items)
                        hotellist.Hrs=[];
                        let i = 0;
                        items.forEach(element=>{
                            element.getText().then(text=>{
                                driver.executeScript("arguments[0].scrollIntoView()", element);
                                console.log("HRS:")
                                console.log(text)

                                //HRS:
                                /*
                                 [0]
                                 [2] Hotelname
                                 [3]
                                 [3]
                                 [4]
                                 [5]
                                 [5]

                                 */
                                try{
                                    let words =  text.split("\n");
                                    let  a = new _HP.classes.Hotel(words[2], words[3], words[7], _HP.methods.getPrice(words), "Hrs")
                                    hotellist.Hrs.push(a)
                                }catch (UnsupportedOperationError){
                                    //super error Handler
                                    console.log("ERR <>")
                                }

                            });
                        })

                    }).then(()=>{
                        resolve(JSON.stringify(hotellist))
                    })
                },4000)
            })

        }catch (NoSuchElementError){
            console.log("HRS Element not Found")
            resolve(null)

        }

    })
}
function getExpedia(place,date=null)          {
    return  new Promise(function (resolve) {
        try {
            // open selenium
            var driver = new webdriver.Builder().forBrowser('firefox').build();
            // maximize the window
            driver.manage().window().maximize();
            // delete all cookies
            driver.manage().deleteAllCookies();


            // navigate to Trivago
            driver.open()
            driver.get(`https://www.expedia.de/`);


            driver.getTitle().then(function(title) {
                console.log(title)
            });

            driver.wait(until.titleIs('Billige Flüge, Hotels & Mietwagen buchen | Expedia.de')).then(function () {

                setTimeout(()=>{

                    let a= driver.findElements(By.className("listing"))
                    a.then(items=>{
                        hotellist.expedia=[];
                        items.forEach(element=>{
                            element.getText().then(text=>{
                                console.log(text)

                                //TRIVAGO:
                                /*
                                 [0]
                                 [1] Hotelname
                                 [2] Ort + Distanz
                                 [3] Bewertung 100
                                 [4] Kommentartbewertungen
                                 [5] Other details
                                 [5] Site

                                 [9] first price

                                 */
                                let words =  text.split("\n");
                                let  a = new _HP.classes.Hotel(words[0], words[5], words[4], _HP.methods.getPrice(words), "expedia")
                                hotellist.expedia.push(a)
                            });
                        })
                    }).then(()=>{
                        resolve(JSON.stringify(hotellist))
                    })

                },2900)
            })

        }catch (NoSuchElementError){
            console.log(NoSuchElementError)
            console.log("Element not Found")
        }

    })
}



/**
 * Parse BookingCOM
 * @param arrayOfWords      required  {string array} of all innerHTML Elements
 * @param firstOrLastPrice  *optional {boolean} || true == first price
 *
 * return new Hotel Obj
 */
function parseBooking(arrayOfWords,firstOrLastPrice=false,start,end,site=null, adult) {

    let counter =0;
    let i =-2;

    let hotel = new Hotel();
        hotel.site      = site;
        hotel.datestart = start;
        hotel.dateend   = end;
        hotel.img = arrayOfWords[arrayOfWords.length-1]

    try{
      JSON.parse(JSON.stringify(arrayOfWords)).forEach(item=>{

        //Price
        if( item.toUpperCase().indexOf("CHF")!=-1 ||item.toUpperCase().indexOf("€")!=-1  ){
            if(! hotel.price1 || firstOrLastPrice || ! hotel.price2){
                if(adult==2 )
                {
                    if(item.toUpperCase().indexOf("€")!=-1){
                        hotel.price2 = item.substr(item.indexOf('€')+2,item.length);
                    }
                    else if(item.toUpperCase().indexOf("CHF")!=-1){
                        hotel.price2 = item.substr(item.indexOf('CHF')+4,item.length);
                    }
                    hotel.price2 =  hotel.price2.replace(/ /g,'')
                    return;
                }
            if(adult==1) {
                    if(item.toUpperCase().indexOf("€")!=-1){
                        hotel.price1 = item.substr(item.indexOf('€')+2,item.length);
                    }
                    else if(item.toUpperCase().indexOf("CHF")!=-1){
                        hotel.price1 = item.substr(item.indexOf('CHF')+4,item.length);
                    }
                    hotel.price1 =  hotel.price1.replace(/ /g,'')
                }
            }
        }


        //Hotelname
        let nameindex =  item.toUpperCase().indexOf("-STERNE")

        if( nameindex >= 0 && !hotel.name )
        {
            hotel.stars  =  item.substr(nameindex -1, 8).replace('Wird in neuem Fenster geöffnet','').replace('-Sterne','');
            hotel.name  =  item.substring(0,nameindex - 2).replace(' Wird in neuem Fenster geöffnet','').replace('"',"").replace('"',"");
            while(/\s+$/.test(hotel.name))
            {

                hotel.name = hotel.name.substring(0,hotel.name.length-1)
            }

            //next item will be place
            i=counter;
        }

        /*2 Hotelname*/
        if(!hotel.name && item.indexOf('Wird in neuem Fenster geöffnet') >=3 )
        {
            if(item.length>=20)
            hotel.name = item.substr(0,item.indexOf(' Wird in neuem Fenster')).replace('"',"").replace('"',"")
            if(/\s+$/.test(hotel.name))
                while(/\s+$/.test(hotel.name)){
                    hotel.name = hotel.name.substring(0,hotel.name-1)
                }
        }

        //Place
        if(counter==i+1 || item.indexOf('Auf der Karte anzeigen')>=0 || item.indexOf('In U-Bahn-Nähe')>0 )
        {

            hotel.place = item.replace(' – Auf der Karte anzeigen','');
            hotel.place =  hotel.place.replace('  – In U-Bahn-Nähe','');
            hotel.place =  hotel.place.replace('– In U-Bahn-Nähe','');
            if(hotel.place.indexOf('(')>=0)
            {
                hotel.place = hotel.place.substr(0, hotel.place.indexOf(' ('))
            }

        }

        //rating
        if(!hotel.rating && item.indexOf(',')>=0)
        {
            bewertung.forEach(i=>{
                if(item.toUpperCase().indexOf(i.toUpperCase())>=0)
                    hotel.rating = item.substr(item.length-3,item.length);
            })
        }

        //amount left
        if(!hotel.roomleft && item.indexOf('Nur noch')>=0)
        {
           let str = item.indexOf('Zimmer')-2
           hotel.roomleft = item.substring(str, str+8)
        }

        //Inclusive
        if(item.indexOf('inbegriffen')>=0){
            hotel.inclusive = item;
        }

        //cancellation
        if(item.indexOf('Stornierung')>=0){
            hotel.cancellation = item;
        }

        //Personenzahl (DOPPELZIMMER)
        if(item.indexOf('Personenzahl')>=0 || item.indexOf('Personenzahl')>=0){
            hotel.people = item;
        }


        //remove false elements
        if(hotel.name)
        if(hotel.name.indexOf('verfügbaren Zimmer')>=0){
            hotel.name=null
        }


        counter++;

    })
    }catch (TypeError){
        console.error(TypeError)
    }

    return hotel;
}
function parseMobileBooking(arry,adult,start,end,place,destid) {
    console.log(" ");
    console.log("start parse id: "+destid+" date: "+start+" ADULT:" + adult)

    const dt= start;
    const city = {
        name:place.replace('+'," "),
        id:destid,
        values:[]
    };


    //add new destID
    let cityindex = hotellist.Booking.findIndex(b=>b.id==destid);

    if(cityindex==-1)
        hotellist.Booking.push(city);

    //add new date
    cityindex = hotellist.Booking.findIndex(b=>b.id==destid)
    const dateindex = hotellist.Booking[cityindex].values.findIndex(b=>b.date==dt)

    if(dateindex==-1)
        hotellist.Booking[cityindex].values.push({
            'date':start,
            values:[]
        })


    return new Promise((resolve)=>{
    let addedtot    = 0;
    let updatettot  = 0
        try{
    arry.forEach(hotel=> {

        const parsedhotel                     = new Hotel();
        parsedhotel.price                     = '0.00';
        parsedhotel.price2                    = '0.00';
        parsedhotel.name                      = '';

        parsedhotel.name                      =  hotel.hotel_name;
        parsedhotel.datestart                 =  start;
        parsedhotel.dateend                   =  end;
        parsedhotel.stars                     =  hotel.class;
        parsedhotel.people                    =  adult;
        parsedhotel.place                     =  hotel.district;
        parsedhotel.city                      =  hotel.city;
        parsedhotel.address                   =  hotel.address;
        parsedhotel.rating                    =  hotel.facilities_review_score['rating'];
        parsedhotel.ranking                   =  hotel.ranking;
        parsedhotel.peopleview                =  hotel.last_reservation_text;
        parsedhotel.roomleft                  =  hotel.available_rooms
        parsedhotel.id                        =  hotel.hotel_id;
        parsedhotel.district_id               =  hotel.district_id;
        parsedhotel.currency_code             =  hotel.currency_code;
        parsedhotel.zip                       =  hotel.zip;
        parsedhotel.hotel_include_breakfast   =  hotel.hotel_include_breakfast
        parsedhotel.description               =  hotel.short_description
        parsedhotel.preferred                 =  hotel.preferred
        parsedhotel.latitude                  =  hotel.latitude
        parsedhotel.longitude                 =  hotel.longitude
        parsedhotel.geodata                   =  hotel.latitude+','+hotel.longitude
        parsedhotel.site                     =   'Booking.com';
        if(hotel.last_reservation_text){
            parsedhotel.last_reservation          =  hotel.last_reservation_text.replace('Letzte Buchung: vor ','').replace(' Stunden','').replace(' Stunde','').replace(' gestern','');;
        }

        if(parsedhotel.last_reservation){

        if(hotel.last_reservation_text.indexOf('Stunde')>=0)
            parsedhotel.last_reservation = moment().subtract(parseInt(parsedhotel.last_reservation),'hours').unix();

        if(hotel.last_reservation_text.indexOf('gestern')>=0)
           parsedhotel.last_reservation = moment().subtract(24,'hours').unix();

         if(hotel.last_reservation_text.indexOf('.')>=0){
               const startidx  = hotel.last_reservation_text.indexOf('.');
               const monthname = hotel.last_reservation_text.substr(startidx+2,hotel.last_reservation_text.length)
                const daynr  =   hotel.last_reservation_text.substr(startidx-2,2)
                const monthnr  = moment().locale("de").month(monthname).format("MM")
                const year = moment().format('YYYY')
                const string = `${year}-${monthnr}-${daynr}`
                parsedhotel.last_reservation = moment(string,'YYYY-MM-DD').unix()
            }

        }


    //const
    const cindex             = hotellist.Booking.findIndex(b=>b.id==destid)
    const dindex             = hotellist.Booking[cindex].values.findIndex(b=>b.date==dt)
    const    idx             =  hotellist.Booking[cindex].values[dindex].values.findIndex(i=>i.name == parsedhotel.name);


     if(!parsedhotel.name)return;

    //new Hotel Price 1
    if(     idx == -1 && adult == 1)
    {
            parsedhotel.price1                    =  hotel.min_total_price;
            hotellist.Booking[cindex].values[dindex].values.push(parsedhotel);
            addedtot++;
        }
    //new Hotel Price 2
    else if(idx == -1 && adult == 2)
    {

        parsedhotel.price2                    =  hotel.min_total_price;
        hotellist.Booking[cindex].values[dindex].values.push(parsedhotel);
        addedtot++;
    }
    //add Price 2 to Hotel
    else if(idx >-1   && adult == 2)
    {
        hotellist.Booking[cindex].values[dindex].values[idx].price2 = hotel.min_total_price;
        updatettot++;
    }

  });


    console.log("========================")
    console.log("total added "+addedtot)
    console.log("updatet added "+updatettot)
    console.log("date "  +start)
    console.log("destid "+destid)
    console.log("total " +arry.length)
    console.log(" ")
     if(arry.length==0){
         resolve(0);
     }

     resolve(adult);
        }catch (TypeError){
            console.log("no result")
            resolve(0);
        }
    })

}
function parseTrivago(arrayOfWords,start,end,site=null){

function getObjectKey(obj, keyToFind) {
    if(keyToFind.indexOf('CHF')>=0)return null;
    var i = 0, key;

        for (key in obj) {
            if (key.toUpperCase().indexOf(keyToFind.toUpperCase())>=0) {
                return key;
            }

            i++;
        }
        return null;
    }

    //TRIVAGO:
    /*
     [0]
     [1] name
     [2] Ort + Distanz
     [3] Bewertung 100
     [4] Kommentartbewertungen

     */

const array = JSON.parse(JSON.stringify(arrayOfWords))

    const hotel = new Hotel();
    hotel.name = array[1];
    hotel.place     = array[2];


    hotel.site      = site;
    hotel.datestart = start;
    hotel.dateend   = end;

    let previtem;
    let counter =0;
    let i =0;
    let prices = {
        "mainprice":null,
        "Hotelwebseite":"",
        "Elvoline":"",
        "Expedia":"",
        "Booking.com":"",
        "Hotels.com":"",
        "HRS.com":"",
        "Hotel.info":"",
        "otel.com":"",
        "Tui.ch":"",
        "Hotelopia":"",
    };

    array.forEach(item=>{

           //Price
        if( item.toUpperCase().indexOf("CHF")!=-1 ){


            const  index = getObjectKey(prices, previtem.toString().replace(" ","") )
            if(index!=null)
                prices[index] = item;

            if(prices.mainprice==null)
                prices.mainprice = item;

            hotel.price = prices;

        }

        //rating
        if(item){
            if(item.length == 2 ){
                hotel.rating = item;
            }
        }


        //Inclusive
        if(item.indexOf('inbegriffen')>=0 ||item.indexOf('Gratis')>=0 ||item.indexOf('Gratis')>=0  ){
            hotel.inclusive = item;
        }


        counter++;
        previtem = item;

    })

    return hotel;
}


function generateJson(array,job,dbid,date,slave=null,send=true){
return new Promise(resovle=>{
    const bodyjob={
        "linkcity":dbid,
        "destid":array[0].id,
        "job":{
            id:job,
            ez:-1,
            dz:-1
        },
        "cityname":array[0].name,
        "date":date,
        "data":array[0].values,
        "dbid":dbid,
        "slave":slave
    };
    resovle(bodyjob);
    return;


    let starturl = '';
    let endurl = `]&job={"JobID":"${job.toString()}","foundEZ":"-1","foundDZ":"-1""pages":"0"}`;

    /*
    try{
    array.forEach(city=>{
        const cname =city.name;
        const destid =city.id;
        city.values.forEach(dates=>{

            const cdate =dates.date;
            if(skipjobs.Booking.indexOf(cdate)==-1)
            {
                skipjobs.Booking.push(cdate)
                starturl = `city=${dbid}&datumList=["${cdate}"]&los=1&data=[`
                dates.values.forEach(h=>{
                    let hotel = new Hotel();
                    hotel     = h;

                    values   += hotel.printToURL()+`,`
                })
            }

        })

        let str = starturl +values.substr(0,values.length-1)+ endurl
        sendResult(str,true)


    })
    }
    catch (TypeError)
    {
     console.error(TypeError)
    }
*/
    return joburls
})
}
function sendResult(_body, active=true){
    return new Promise(resolve=>{


    if(!active)return;
         //&gateway='+_SERVER.os.hostname().replace('slave','')
        console.log("sending data to host")
        const reciverurl='http://192.168.56.1:88/sendtestdb';
        request.post({
            headers: {'content-type' : 'application/x-www-form-urlencoded'},
            url:      reciverurl,
            json: true,
            form:  {
                data: JSON.stringify(_body)
            }
        },
            function(error, response, body){
                resolve(body);
        });


    return;
    request.post({
            headers: {'content-type' : 'application/x-www-form-urlencoded'},
            url:     'http://192.168.56.1:202/api/v1',
            body:    JSON.stringify(_body)
        },
        function(error, response, body){
            console.log(body);
        });

    })

}

//###Export
module.exports ={
    "db"     :connection,
    "hotels" :hotellist,
    "jobs"   :{
        "urls":joburls,
        "skip":skipjobs
    },
    "classes":{
        "Hotel":Hotel
    },
    "methods":{
        "general": {
            generateJson:generateJson
        },
         "Booking":{
             "get":        getBooking,
            "parse":       parseBooking,
             "parsemobile":parseMobileBooking

         },
         "Trivago":{
            "get":getTrivago,
            "parse":parseTrivago
         }
    },
};

//###Error Output
process.on('uncaughtException', function (error) {
    console.log(error.stack);
});
process.on('TypeError',         function (error) {
    console.log(error.stack);
});